﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

// https://stackoverflow.com/questions/49636326/pass-c-sharp-byte-to-c-api

using System.Runtime.InteropServices; // <--
using System.IO;

namespace WindowsFormsApp1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            Text = Directory.GetCurrentDirectory();
        }

        // c:\temp ... nouzove reseni
        // [DllImport("c:\\temp\\DynamicLibrary1.dll", CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]

        // [DllImport("c:\\Users\\Zdenek\\source\\repos\\WindowsFormsApp1\\Debug\\DynamicLibrary1.dll", CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]

        [DllImport("..\\..\\..\\Debug\\DynamicLibrary1.dll", CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        public static extern int sum ([In, Out][MarshalAs(UnmanagedType.LPArray)] int[] data, int length);

        private void button1_Click(object sender, EventArgs e)
        {
            int[] a = { 10, 20, 30 };
            int t = sum (a, a.Length);
            button1.Text = "sum = " + t;
        }
    }
}
